runOn:
    -
        minServerVersion: "4.1.0"
        topology: ["replicaset", "sharded"]

data:
    - { _id: 1, x: 11 }
    - { _id: 2, x: 22 }
    - { _id: 3, x: 33 }

collection_name: &collection_name 'test_aggregate_out_readconcern'

tests:
  -
    description: "readConcern majority with out stage"
    operations:
      -
        object: collection
        name: aggregate
        collectionOptions:
          readConcern: { level: "majority" }
        arguments: &arguments
          pipeline:
            - $sort: { x : 1 }
            - $match: { _id: { $gt: 1 } }
            - $out: &output_collection "other_test_collection"
    expectations:
      -
        command_started_event:
          command:
            aggregate: *collection_name
            pipeline: &pipeline
              - $sort: { x: 1 }
              - $match: { _id: { $gt: 1 } }
              - $out: "other_test_collection"
            readConcern: { level: "majority" }
    outcome: &outcome
      collection:
        name: *output_collection
        data:
          - { _id: 2, x: 22 }
          - { _id: 3, x: 33 }
  -
    description: "readConcern local with out stage"
    operations:
      -
        object: collection
        name: aggregate
        collectionOptions:
          readConcern: { level: "local" }
        arguments: *arguments
    expectations:
      -
        command_started_event:
          command:
            aggregate: *collection_name
            pipeline: *pipeline
            readConcern: { level: "local" }
    outcome: *outcome
  -
    description: "readConcern available with out stage"
    operations:
      -
        object: collection
        name: aggregate
        collectionOptions:
          readConcern: { level: "available" }
        arguments: *arguments
    expectations:
      -
        command_started_event:
          command:
            aggregate: *collection_name
            pipeline: *pipeline
            readConcern: { level: "available" }
    outcome: *outcome
  -
    description: "readConcern linearizable with out stage"
    operations:
      -
        object: collection
        name: aggregate
        collectionOptions:
          readConcern: { level: "linearizable" }
        arguments: *arguments
        error: true
    expectations:
      -
        command_started_event:
          command:
            aggregate: *collection_name
            pipeline: *pipeline
            readConcern: { level: "linearizable" }
  -
    description: "invalid readConcern with out stage"
    operations:
      -
        object: collection
        name: aggregate
        collectionOptions:
          readConcern: { level: "!invalid123" }
        arguments: *arguments
        error: true
    expectations:
      -
        command_started_event:
          command:
            aggregate: *collection_name
            pipeline: *pipeline
            readConcern: { level: "!invalid123" }
